<?php

namespace Ads\Ad\Policies;

use App\User;
use Illuminate\Auth\Access\HandlesAuthorization;
use Ads\Ad\Models\Asd;

class AsdPolicy
{
    use HandlesAuthorization;

    /**
     * Determine if the given user can view the asd.
     *
     * @param User $user
     * @param Asd $asd
     *
     * @return bool
     */
    public function view(User $user, Asd $asd)
    {
        if ($user->canDo('ad.asd.view') && $user->is('admin')) {
            return true;
        }

        return $user->id === $asd->user_id;
    }

    /**
     * Determine if the given user can create a asd.
     *
     * @param User $user
     * @param Asd $asd
     *
     * @return bool
     */
    public function create(User $user)
    {
        return  $user->canDo('ad.asd.create');
    }

    /**
     * Determine if the given user can update the given asd.
     *
     * @param User $user
     * @param Asd $asd
     *
     * @return bool
     */
    public function update(User $user, Asd $asd)
    {
        if ($user->canDo('ad.asd.update') && $user->is('admin')) {
            return true;
        }

        return $user->id === $asd->user_id;
    }

    /**
     * Determine if the given user can delete the given asd.
     *
     * @param User $user
     * @param Asd $asd
     *
     * @return bool
     */
    public function delete(User $user, Asd $asd)
    {
        if ($user->canDo('ad.asd.delete') && $user->is('admin')) {
            return true;
        }

        return $user->id === $asd->user_id;
    }

    /**
     * Determine if the user can perform a given action ve.
     *
     * @param [type] $user    [description]
     * @param [type] $ability [description]
     *
     * @return [type] [description]
     */
    public function before($user, $ability)
    {
        if ($user->isSuperUser()) {
            return true;
        }
    }
}
